﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/user_input_handler_registry.php';
class SmartEntryHandler
    implements UserInputHandler
{
    private $vod;

    public function __construct($vod)
    {
        $this->vod = $vod;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    public function get_handler_id()
    {
        return 'entry';
    }
	
    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
		$control_id = isset($user_input->control_id) ? $user_input->control_id : '';
		$start_tv = isset($plugin_cookies->start_tv) ? $plugin_cookies->start_tv : 0;
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ($control_id == 'codec_install'){
			$add_params = array('name' => 'Codec_install');
            $url = 'plugin_installer://http://dune-club.info/plugins/update/Codec_install/dune_plugin_Codec_install_v5.0.0.tar.gz:::name=Codec_install&space_needed=2000000&need_confirm_replace=0';
			return ActionFactory::launch_media_url($url,UserInputHandlerRegistry::create_action($this, 'refresh', $add_params));	
		}
		else if ($control_id == 'run_codec_install'){
			$url = 'plugin_launcher://Codec_install';
			return ActionFactory::launch_media_url($url);
		}
		if ($control_id == 'run')
        {
			HD::save_item('codec_install','tru');
			if (($start_tv == 0)&&($control_id == 'entry_enter'))
				return ActionFactory::open_folder();
			if (($start_tv == 0)&&($control_id == 'entry_play'))
				return ActionFactory::tv_play();
			if (($start_tv == 1)&&($control_id == 'entry_enter'))
				return ActionFactory::tv_play();
			if (($start_tv == 1)&&($control_id == 'entry_play'))
				return ActionFactory::open_folder();
		}
		else if ($user_input->control_id === 'sel_pl_folder'){
                $media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'pl_folder'
                    )
                );
				return ActionFactory::open_folder($media_url,'%tr%t1');
		}
		else if ($user_input->control_id === 'pl_select'){
                $media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent'		=> 'tv_group_list',
						'action'		=> 'pl_folder',
						'arg'			=> 0,
						'extension'		=> 'm3u'
						),
                    )
				);
				return ActionFactory::open_folder($media_url,'%tr%t2');
		}
		else if ($user_input->control_id == 'prov_pl'){
			$defs = array();		
			$ch_ops = HD::load_prov_info();
			ControlFactory::add_combobox($defs, $this, null,
            'do_new_url', '%tr%t19',
            0, $ch_ops, 500, $need_confirm = false, $need_apply = false
			);
			$do_prov_pl_apply = UserInputHandlerRegistry::create_action($this, 'do_url');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
			'_prov_pl_apply', '%tr%t21', 250, $do_prov_pl_apply);
			return  ActionFactory::show_dialog('%tr%t3', $defs, true);
		}
		else if ($user_input->control_id === 'pltxt_select'){
                $media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent'		=> 'tv_group_list',
						'action'		=> 'pl_folder',
						'arg'			=> 0,
						'extension'		=> 'txt'
						),
                    )
				);
				return ActionFactory::open_folder($media_url,'%tr%t2');
		}
		else if ($user_input->control_id === 'url_select'){
			$defs = array();
			ControlFactory::add_text_field($defs,
			$this, $add_params=null,
			'do_new_url', '',
			'http://', 0, 0, 1, 1, 1300,0,1);
			ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t4', $defs, true);
		}
		else if ($user_input->control_id == 'do_new_url'){
			$do_search = UserInputHandlerRegistry::create_action($this, 'do_url');
			return ActionFactory::close_dialog_and_run($do_search);
		}
		else if ($user_input->control_id === 'do_url'){
			$link = DuneSystem::$properties['data_dir_path'] . '/pl_folder';
			$pl_folders = unserialize(file_get_contents($link));
			$pl_folders[]['pl_url'] = $user_input->do_new_url;
			$data = fopen($link,"w");
			if (!$data)
				return ActionFactory::show_title_dialog('%tr%t5');
			fwrite($data, serialize($pl_folders));
			@fclose($data);
			return ActionFactory::open_folder();
		}
		else if (($control_id == 'entry_enter')||($control_id == 'entry_play')){
			$defs = array();
			if ((!file_exists('/codecpack'))&&(!file_exists(SmartConfig::get_data_path() . '/codec_install'))){
				ControlFactory::add_multiline_label($defs,'' ,'%tr%t6',5);
				$codec_install = UserInputHandlerRegistry::create_action($this, 'codec_install');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'codec_install', '%tr%t7', 800, $codec_install);
				$run = UserInputHandlerRegistry::create_action($this, 'run');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'run', '%tr%t8', 800, $run);
				ControlFactory::add_close_dialog_button($defs,'%tr%t9', 800);
				return ActionFactory::show_dialog('%tr%t10', $defs, true, 800, $attrs);
			}
			if ((!file_exists('/codecpack'))&&(file_exists(str_replace('liteIPTV', 'Codec_install', DuneSystem::$properties['install_dir_path'])))){
				ControlFactory::add_multiline_label($defs,'' ,'%tr%t11',4);
				$run_codec_install = UserInputHandlerRegistry::create_action($this, 'run_codec_install');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'run_codec_install', '%tr%t12', 800, $run_codec_install);
				ControlFactory::add_close_dialog_button($defs,'%tr%t9', 800);
				return ActionFactory::show_dialog('%tr%t13', $defs, true, 800, $attrs);
			}
			if (!file_exists(SmartConfig::get_data_path() . '/vsetv_channels_id')){
				$doc = iconv('WINDOWS-1251', 'UTF-8',HD::http_get_document('http://www.vsetv.com/channels.html'));
				preg_match_all('|<option value=channel_(.*?)>(.*?)</option>|ms', $doc, $matches);
				foreach ($matches[2] as $k => $v){
					$vsetv_channels_id[HD::get_id_key($v)] = $matches[1][$k];
					$vsetv_channels[$v] = $matches[1][$k];
				}
				HD::save_items('vsetv_channels_id', $vsetv_channels_id);
				HD::save_items('vsetv_channels', $vsetv_channels);
			}
			
			if ((file_exists('/codecpack'))||(file_exists(SmartConfig::get_data_path() . '/codec_install'))){
				$link = DuneSystem::$properties['data_dir_path'] . '/pl_folder';
				if (file_exists($link))
					$pl_folders = unserialize(file_get_contents($link));
				if ((!file_exists($link))||(empty($pl_folders))){
					ControlFactory::add_multiline_label($defs,'' ,'%tr%t14',5);
					$run = UserInputHandlerRegistry::create_action($this, 'sel_pl_folder');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pl_folder', '%tr%t15', 450, $run);
					$run = UserInputHandlerRegistry::create_action($this, 'pl_select');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pl_select', '%tr%t16', 450, $run);
					$run = UserInputHandlerRegistry::create_action($this, 'pltxt_select');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pltxt_select', '%tr%t17', 450, $run);
					$run = UserInputHandlerRegistry::create_action($this, 'url_select');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'url_select', '%tr%t18', 450, $run);
					$run = UserInputHandlerRegistry::create_action($this, 'prov_pl');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'prov_pl', '%tr%t19', 450, $run);
					ControlFactory::add_close_dialog_button($defs,'%tr%t9', 400);
					return ActionFactory::show_dialog('%tr%t20', $defs, true, 1100, $attrs);
				}
				if (($start_tv == 0)&&($control_id == 'entry_enter'))
					return ActionFactory::open_folder();
				if (($start_tv == 0)&&($control_id == 'entry_play'))
					return ActionFactory::tv_play();
				if (($start_tv == 1)&&($control_id == 'entry_enter'))
					return ActionFactory::tv_play();
				if (($start_tv == 1)&&($control_id == 'entry_play'))
					return ActionFactory::open_folder();
			}
		}	
    }
}

///////////////////////////////////////////////////////////////////////////
?>
