<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';
require_once 'Smart_channel.php';
require_once 'lib/user_input_handler_registry.php';
///////////////////////////////////////////////////////////////////////////

class SmartM3uTv extends AbstractTv 
implements UserInputHandler

{
	private $finalUrl = null;
	private $currentlUrls = null;
	private $currentId = false;
	public $global_channels = null;
	public $nbr_channels = null;
	public function get_handler_id() 
	{ return "tv"; }
	
    public function __construct()
    {
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            SmartConfig::TV_FAVORITES_SUPPORTED,
            false);
			
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    public function get_fav_icon_url()
    {
        return SmartConfig::get_plugin_ico('tv_favorites');
    }
	
    ///////////////////////////////////////////////////////////////////////
	public function folder_entered(MediaURL $media_url, &$plugin_cookies) {
	if ($media_url->get_raw_string() == 'tv_group_list')
                $this->load_channels($plugin_cookies);            
    }
    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    private static function get_icon_path($channel_id)
	{
		if (file_exists(SmartConfig::get_data_path() . "/logo/$channel_id.png"))
			$icon_path = SmartConfig::get_data_path() . "/logo/$channel_id.png";
		else if (file_exists(DuneSystem::$properties['install_dir_path'] . "/logo/$channel_id.png"))
			$icon_path = "plugin_file://logo/$channel_id.png";
		else if (preg_match("|[-a-zA-Z]|", $channel_id))
			$icon_path = "plugin_file://logo/0.png";
		else
			$icon_path = "plugin_file://logo/00.png";
		return $icon_path; 
	}

    ///////////////////////////////////////////////////////////////////////

    protected function load_channels(&$plugin_cookies)
    {
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
		$sort_channels = isset($plugin_cookies->sort_channels) ? $plugin_cookies->sort_channels : 0;
		$this->channels = new HashedArray();
        $this->groups = new HashedArray();
        if ($this->is_favorites_supported())
        {
            $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    '%tr%t62',
                    SmartConfig::get_plugin_ico('tv_favorites')));
        }

        $all_channels_group = 
            new AllChannelsGroup(
                $this,
                '%tr%t63',
                SmartConfig::get_plugin_ico('__all_channels'));

        $this->groups->put($all_channels_group);
		$channels_id_parsed = array_merge(
		HD::get_items('vsetv_channels_id'), 
		HD::get_items('my_channels_id')
		);
		$channels_name = array_flip (array_merge(
			HD::get_items('vsetv_channels'), 
			HD::get_items('vsetv_list')
		));
		$group_defs = HD::get_items('grups_id');
		$parental_defs = HD::get_items('parental');
		$hide_ch_defs = HD::get_items('hide_ch');
		$chnmbr_list = array_flip (HD::get_items('chnmbr_list'));
		$m3u_files = HD::get_m3u();
		if ($m3u_files==false)
			$this->global_channels = false;
		if (($this->global_channels == null)||($this->currentlUrls == null)||($this->currentlUrls != $m3u_files)){
			$this->global_channels = $m3u_lines = false;
			echo 'start count m3u:'.(count($m3u_files));
			$otps[CURLOPT_TIMEOUT] = 10;
			$this->currentlUrls = $m3u_files;
			if ($m3u_files!=false)
			foreach ($m3u_files as &$iptv_item){
				$m3u_lines = array();
				if (preg_match('/http:|https:/', $iptv_item)){
					$web_pls = HD::http_get_document($iptv_item, $otps);
					if (!preg_match('//u', $web_pls))
						$web_pls = iconv('WINDOWS-1251', 'UTF-8', $web_pls);
					if (!preg_match('|#EXTINF:|', $web_pls))
						$file_pls = "По ссылке $iptv_item плейлиста нет.\n".DuneSystem::$properties['install_dir_path'].'/icons/nostream.png';
					$web_pls = str_replace("\r", "", $web_pls);
					$m3u_lines = explode ("\n", $web_pls);
				}else if (file_exists($iptv_item))
					$m3u_lines = file($iptv_item, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
				if ($m3u_lines==true)
				foreach ($m3u_lines as $line)
				{
					$is_protected = 0; $gid='null';
					$line = trim($line);
					if (preg_match('/\.m3u$/i', $line)){
						if (!isset($m3u_files[$line]))
							$m3u_files[$line] = $line;
						continue;
					}
					if ($line =='')
						continue;
					if (preg_match('|#EXTM3U|i', $line))
						continue;
					if (preg_match('/^#EXTVLCOPT:|^#EXTGRP:|^#EXT-INETRA/', $line))
						continue;
					if (preg_match('/^#EXTINF:[^,]*,(.+)$/', $line, $matches)) {
						$caption = trim($matches[1]);
						continue;
					}
					$caption = ($caption == '') ? $line : $caption;
					$id_key = HD::get_id_key($caption);
					$id = array_key_exists($id_key,$channels_id_parsed) ? $channels_id_parsed[$id_key] : $id_key;
					$group_id = (array_key_exists($id, $group_defs)) ? $group_defs[$id] : 'all';
					if ($group_id!='all')
						list ($gid, $gname) = SmartConfig::get_group_name($group_id);
					if ($pin == '1111')
						$is_protected = 0;
					else
						$is_protected = (array_key_exists($id, $parental_defs)) ? 1 : 0;
					$new=false;
					if (!isset($this->global_channels[$id]))
						$new=true;
					$this->global_channels[$id]['urls'][$line] = $iptv_item;
					$this->global_channels[$id]['caption'][$line] = $caption;
					$is_hide = (array_key_exists($id, $hide_ch_defs)) ? 1 : 0;
					$caption = isset($channels_name[$id]) ? $channels_name[$id] : $caption;
					if (($sort_channels == 2)||($sort_channels == 3)){
						if (isset($chnmbr_list[$id]))
							$n = $chnmbr_list[$id] + 1;
						else
							$n =-1;
					}else
						$n =-1;
					if (($new==true)&&($is_hide != 1)){
						$channel =
							new SmartChannel(
								$id,
								$caption,
								self::get_icon_path($id),
								$id,
								$n,
								self::get_future_epg_days($id),
								self::get_future_epg_days($id),
								$is_protected, 
								$buf_time,
								0
								);
						
						if ((!($this->groups->has($gid)))&&($group_id!='all')) {
							$this->groups->put(
									new DefaultGroup(
										strval($gid),
										strval($gname),
										SmartConfig::get_plugin_ico($gid)));
						}	
						$this->channels->put($channel);
						if ($group_id!='all'){
							$group = $this->groups->get($gid);
							$channel->add_group($group);
							$group->add_channel($channel);
						}
					}
				}
			}
			echo 'stop count m3u:'. (count($m3u_files));
			
		}else{
			echo 'reload';
			foreach ($this->global_channels as $id => $v)
			{
				$is_protected = 0; $gid='null';
				$caption = array_shift ($v['caption']);//??
				$group_id = (array_key_exists($id, $group_defs)) ? $group_defs[$id] : 'all';
				if ($group_id!='all')
					list ($gid, $gname) = SmartConfig::get_group_name($group_id);
				if ($pin == '1111')
					$is_protected = 0;
				else
					$is_protected = (array_key_exists($id, $parental_defs)) ? 1 : 0;
				$is_hide = (array_key_exists($id, $hide_ch_defs)) ? 1 : 0;
				$caption = isset($channels_name[$id]) ? $channels_name[$id] : $caption;
				if (($sort_channels == 2)||($sort_channels == 3)){
						if (isset($chnmbr_list[$id]))
							$n = $chnmbr_list[$id] + 1;
						else
							$n =-1;
				}else
					$n =-1;
				if ($is_hide != 1){
					$channel =	new SmartChannel(
						$id,
						$caption,
						self::get_icon_path($id),
						$id,
						$n,
						self::get_future_epg_days($id),
						self::get_future_epg_days($id),
						$is_protected, 
						$buf_time,
						0
					);

					if ((!($this->groups->has($gid)))&&($group_id!='all')) {
						$this->groups->put(
						new DefaultGroup(
							strval($gid),
							strval($gname),
							SmartConfig::get_plugin_ico($gid)));
					}	
					$this->channels->put($channel);
					if ($group_id!='all'){
						$group = $this->groups->get($gid);
						$channel->add_group($group);
						$group->add_channel($channel);
					}
				}
			}
		}
		if ($sort_channels > 0) {
			if ($sort_channels == 1)
				$sort_cb = SmartConfig::CHANNEL_SORT_FUNC_CB;
			if ($sort_channels == 2)
				$sort_cb = SmartConfig::CHANNEL_SORT_FUNC_BC;
			if ($sort_channels == 3)
				$sort_cb = SmartConfig::CHANNEL_SORT_FUNC_BA;
			$this->channels->usort($sort_cb);
			foreach ($this->groups as $g) {
				if ((isset($g->id))&&($g->id == '__favorites')) continue;
					$g->sort_channels($sort_cb);
			}
			if (($sort_channels == 2)||($sort_channels == 3)){
				$group_all_channels = $this->get_group("__all_channels");
				foreach ($group_all_channels->get_channels($plugin_cookies) as $ch)
					$cc[] = $ch->get_id();
				HD::save_items('chnmbr_list', $cc);
			}
			if ($sort_channels == 1){
				$group_all_channels = $this->get_group("__all_channels");
				foreach ($group_all_channels->get_channels($plugin_cookies) as $ch)
					$cc[] = $ch->get_id();
				$this->nbr_channels = $cc;
			}
		}
		
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    { 
		$epg_shift = isset($plugin_cookies->epg_shift) ? $plugin_cookies->epg_shift : 0;
		if (preg_match("|[a-zA-Z]|", $channel_id))
			return array();
		$epg_result = array();
		$epg = HD::get_vsetv_epg($channel_id, $day_start_ts);
		foreach ($epg as $time => $value) {
			$epg_result[] =
					new DefaultEpgItem(
						strval($value["name"]),
						strval($value["desc"]),
						intval($time + $epg_shift),
						intval(-1));
		}
		return
				new EpgIterator(
					$epg_result,
					$day_start_ts,
					$day_start_ts + 100400);
    }
	
	private static function get_future_epg_days($channel_id)
    { 
		$days = 3;
		if (preg_match("|[-a-zA-Z]|", $channel_id))
			$days = 0;
		return $days;
    }
	
	public function get_tv_stream_url($playback_url, &$plugin_cookies)
    {
		echo "1=iptv=>" . $playback_url;
		$this->finalUrl = $playback_url;
		if (preg_match("|^udp:\/\/\d|",$playback_url))
			$url = preg_replace("/^udp:\/\//", "udp://@", $playback_url);
		else if (substr(strtolower($playback_url), 0, 12) == 'http://ts://')
			$url = $playback_url;
		else if (substr(strtolower($playback_url), 0, 22) == 'http://audio_stream://')
			$url = $playback_url;
		else if (substr(strtolower($playback_url), 0, 11) == 'http://ts//')
			$url = str_replace('http://ts//', 'http://ts://', $playback_url);
		else if (substr(strtolower($playback_url), 0, 13) == 'http://mp4://')
			 $url = $playback_url;
		else if (substr(strtolower($playback_url), 0, 12) == 'http://mp4//')
			 $url = str_replace('http://mp4//', 'http://mp4://', $playback_url);
		else if (substr(strtolower($playback_url), 0, 4) == 'rtmp'){
			$f = array('rtmp://$OPT:rtmp-raw=', 'rtmp://', 'rtmpt://','rtmpe://','rtmpte://', ' --', '<playpath>', '<swfUrl>', '<pageUrl>');
			$t = array('', "http://ts://127.0.0.1:81/cgi-bin/rtmp.sh?rtmp://", "http://ts://127.0.0.1:81/cgi-bin/rtmp.sh?rtmpt://","http://ts://127.0.0.1:81/cgi-bin/rtmp.sh?rtmpe://","http://ts://127.0.0.1:81/cgi-bin/rtmp.sh?rtmpte://", ' ',' playpath=', 'swfUrl=', 'pageUrl=');
			$url = str_ireplace($f, $t, $playback_url);
		}
		else if (substr(strtolower($playback_url), 0, 7) == 'rtsp://')
			$url = str_replace('rtsp://', 'http://ts://127.0.0.1:81/cgi-bin/rtsp.sh?rtsp://', $playback_url);
		else if (substr(strtolower($playback_url), -3) == 'flv')
			$url = str_replace('http://', 'http://ts://127.0.0.1:81/cgi-bin/flv.sh?http://', $playback_url);
		// else if (preg_match("/\/.*:.*:.*:.*:.*:.*/i", $playback_url))
			// $url = $playback_url;
		else if (substr(strtolower($playback_url), -4) == 'm3u8')
			$url = $playback_url;
		else if (substr(strtolower($playback_url), 0, 7) == 'http://')
			$url = str_replace('http://', 'http://ts://', $playback_url);
		else
			$url = $playback_url;
		if (preg_match("|127.0.0.1:81\/cgi-bin|",$url))
			HD::get_codec_start_info();
		echo "2=iptv=>" . $url;
		return $url;
    }
	
	public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
        $url = $this->get_channel($channel_id)->get_streaming_url();
		$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
        $nado = $this->get_channel($channel_id)->is_protected();
		$this->currentUrlcid = null;
		if ($nado)
			if ($protect_code !== $pin)  
				return DuneSystem::$properties['install_dir_path'].'/icons/nopass.png';
		$urls = $this->global_channels[$channel_id]['urls'];
		$ch_select = HD::get_items('ch_select');
		$ch_select_all = HD::get_item('ch_select_all');
		$key = array_search($ch_select_all, $urls);
		if ((count($urls))==1)
			$url = key($urls);
		else if ((isset($ch_select[$channel_id]))&&(isset($urls[$ch_select[$channel_id]]))){
			$url = $ch_select[$channel_id];
			if ($this->currentId != $channel_id)
				$this->currentUrl = 0;
			if ($this->currentUrl<5)
				$this->currentUrl = $this->currentUrl +1;
			else{
				foreach ($urls as $k => $v)
					$url_arr[] = $k;
				$c = count($url_arr);
				$url = $url_arr[$this->currentUrl-5];
				if (($this->currentUrl-5)<($c-1))
					$this->currentUrl = $this->currentUrl +1;
				else
					$this->currentUrl = 0;
			}
			$this->currentId = $channel_id;			
		}
		else if (isset($urls[$key])){
			$url = $key;
			if ($this->currentId != $channel_id)
					$this->currentUrl = 0;
			if ($this->currentUrl<5)
				$this->currentUrl = $this->currentUrl +1;
			else{
				foreach ($urls as $k => $v)
					$url_arr[] = $k;
				$c = count($url_arr);
				$url = $url_arr[$this->currentUrl-5];
				if (($this->currentUrl-5)<($c-1))
					$this->currentUrl = $this->currentUrl +1;
				else
					$this->currentUrl = 0;
			}
			$this->currentId = $channel_id;				
		}else{
			if ($this->currentId != $channel_id)
					$this->currentUrl = 0;
			foreach ($urls as $k => $v)
					$url_arr[] = $k;
			$c = count($url_arr);
			$url = $url_arr[$this->currentUrl];
			if ($this->currentUrl<$c-1)
				$this->currentUrl = $this->currentUrl +1;
			else
				$this->currentUrl = 0;
			$this->currentId = $channel_id;
			$this->currentUrlcid = $url;
		}
		$zoom = HD::get_items('zoom', &$plugin_cookies);
		if (isset($zoom[$channel_id]))
			$url = $url . '|||dune_params|||zoom:'.$zoom[$channel_id];
        return $url;
    }
	
	public function handle_user_input(&$user_input, &$plugin_cookies)
    {
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		
		if ($user_input->control_id == 'sleep')
        {
			$defs = array();
			$cron_tab = $sleep_time = '';
			$unix_time = time();
			$save = false;
			$ini = parse_ini_file('/config/settings.properties');
			$cron_tabs = file ('/tmp/cron/crontabs/root');
			foreach ($cron_tabs as $v){
				if (preg_match('|sleep=(.*)|', $v, $matches)){
					if($matches[1] < $unix_time){
						$save = true;
						continue;
					}
					else{
						$tr = HD::min_format_duration($matches[1]-$unix_time);
						$sleep_time = "%ext%<key_local>k__1<p>$tr</p></key_local>";
						ControlFactory::add_label($defs,'%tr%t64', date("H:i (m-d-Y)",($matches[1]- $ini['time_zone'] * 3600)));
					}
				}
				$cron_tab .= $v;
			}
			if ($save === true){
				$cron_data = fopen('/tmp/cron/crontabs/root',"w");
				if (!$cron_data)
					hd_print("НЕ МОГУ ЗАПИСАТЬ cron");
				fwrite($cron_data, $cron_tab);
				@fclose($cron_data);
				chmod('/tmp/cron/crontabs/root', 0575);
				shell_exec('crontab -e');
			}
			
			$sleep_time_hour = 0;
			$sleep_time_ops = array();
			$sleep_time_ops [0] = '%tr%t65';
			$sleep_time_ops [900] = '%tr%t66';
			$sleep_time_ops [1800] = '%tr%t67';
			$sleep_time_ops [2700] = '%tr%t68';
			$sleep_time_ops [3600] = '%tr%t69';
			$sleep_time_ops [4500] = '%tr%t70';
			$sleep_time_ops [5400] = '%tr%t71';
			$sleep_time_ops [6300] = '%tr%t72';
			$sleep_time_ops [7200] = '%tr%t73';
			$sleep_time_ops [9000] = '%tr%t74';
			$sleep_time_ops [10800] = '%tr%t75';
			ControlFactory::add_combobox($defs, $this, null,
				'sleep_time_hour', '%tr%t76',
				$sleep_time_hour, $sleep_time_ops, 0, $need_confirm = false, $need_apply = false
			);
			if ($sleep_time !='')
			ControlFactory::add_button_close ($defs, $this, $add_params=null,'cleer_sleep',
			'%tr%t77', '%tr%t78', 0);	
			
			ControlFactory::add_close_dialog_and_apply_button($defs,
				$this, null,
				'sleep_timer', '%tr%t21', 300, $params=null);
			$sleep = UserInputHandlerRegistry::create_action($this,'sleep',  $params=null);
			$attrs['timer'] = ActionFactory::timer(1000);
			$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($sleep));
			return ActionFactory::show_dialog("%ext%<key_local>l__1<p>$sleep_time</p></key_local>", $defs,true,0,$attrs);
        }
		
		if ($user_input->control_id == 'sleep_timer')
        {
			$cron_tab = '';
			if ($user_input->sleep_time_hour==0)
				return ActionFactory::show_title_dialog_gl('%tr%t79');
			$cron_tabs = file ('/tmp/cron/crontabs/root');
			$unix_time = time() + $user_input->sleep_time_hour;
			foreach ($cron_tabs as $v){
				if (preg_match('|sleep=(.*)|', $v, $matches))
					continue;
				else
					$cron_tab .= $v;
			}
			$cron_tab .= 
			date("i", $unix_time) .' ' .
			date("H", $unix_time) .' ' .
			date("d", $unix_time) .' ' .
			date("m", $unix_time) .
			" * wget --quiet -O - \"http://127.0.0.1/cgi-bin/do?cmd=standby\" #sleep=$unix_time\n";
			$cron_data = fopen('/tmp/cron/crontabs/root',"w");
			if (!$cron_data)
				hd_print("НЕ МОГУ ЗАПИСАТЬ cron");
			fwrite($cron_data, $cron_tab);
			@fclose($cron_data);
			chmod('/tmp/cron/crontabs/root', 0575);
			return null;
		}
		
		if ($user_input->control_id == 'cleer_sleep')
        {
			$cron_tab = '';
			$cron_tabs = file ('/tmp/cron/crontabs/root');
			foreach ($cron_tabs as $v){
				if (preg_match('|sleep=(.*)|', $v, $matches)){
					$save = true;
					continue;
				}
				$cron_tab .= $v;
			}
			if ($save == true){
				$cron_data = fopen('/tmp/cron/crontabs/root',"w");
				if (!$cron_data)
					hd_print("НЕ МОГУ ЗАПИСАТЬ cron");
				fwrite($cron_data, $cron_tab);
				@fclose($cron_data);
				chmod('/tmp/cron/crontabs/root', 0575);
			}
			return UserInputHandlerRegistry::create_action($this,
            'sleep', $params=null);
		}

		if ($user_input->control_id == 'rec_repeat'){
			shell_exec ('echo 9F60BF00 > /proc/ir/button');
		}
		
		if ($user_input->control_id == 'ch_select')
        {
			$defs = array();
			$channel_id = $user_input->plugin_tv_channel_id;
			$channel_urls = $this->global_channels[$channel_id]['urls'];
			$ch_select = HD::get_items('ch_select');
			$ch_select_all = HD::get_item('ch_select_all');
			$key = array_search($ch_select_all, $channel_urls);
			$channell_select_ops['v'] = '%tr%t80';
			foreach ($channel_urls as $k => $v){
				if (!preg_match('|^http|', $v))
					$gname = basename($v);
				else
					$gname = substr($v,0,40);
				$gname .= ':'. substr($k,0,40);
				$channell_select_ops[$k] = $gname;
			}
			ControlFactory::add_smart_label($defs,"", '%tr%t81');
			ControlFactory::add_smart_label($defs,"", '%tr%t82');
			ControlFactory::add_smart_label($defs,"", '%tr%t83');
			ControlFactory::add_smart_label($defs,"", '%tr%t84');
			ControlFactory::add_smart_label($defs,"", '%tr%t85');
			ControlFactory::add_smart_label($defs,"", '%tr%t86');
			ControlFactory::add_vgap($defs, -160);
			if ((count($channel_urls))==1){
				$dune_ch_select = key($channel_urls);
				$msg = '%tr%t87';
			}
			else if ($this->currentUrlcid == true){
				$dune_ch_select = $this->currentUrlcid;
				$msg = '%tr%t88';
			}
			else if ((isset($ch_select[$channel_id]))&&(isset($channel_urls[$ch_select[$channel_id]]))){
				$dune_ch_select = $ch_select[$channel_id];
				$msg = '%tr%t89';
			}
			else if (($key==true)&&(isset($channel_urls[$key]))){
				$dune_ch_select = $key;
				$msg = '%tr%t90';
			}
			else
				$dune_ch_select = reset($channel_urls);
			ControlFactory::add_img_label($defs, '', $msg, 0, 0, 0);
			ControlFactory::add_combobox($defs, $this, null,
            'channell_select', '',
            $dune_ch_select, $channell_select_ops, 1100, $need_confirm = false, $need_apply = false
			);
			ControlFactory::add_close_dialog_and_apply_button($defs,
				$this, null,
				'ch_select_apply', '%tr%t91', 450, $params=null);
			ControlFactory::add_close_dialog_and_apply_button($defs,
				$this, null,
				'ch_select_apply_all', '%tr%t92', 450, $params=null);
			ControlFactory::add_close_dialog_and_apply_button($defs,
				$this, null,
				'ch_select_clear_all', '%tr%t93', 450, $params=null);
			return ActionFactory::show_dialog('%tr%t94', $defs,true,1200,$attrs);
			return $defs;
        }
		
		if ($user_input->control_id == 'ch_select_clear_all')
        {
			$this->currentUrl = 0;
			HD::save_item('ch_select_all', '');
			HD::save_items('ch_select', array());
			shell_exec ('echo EA15BF00 > /proc/ir/button');
			shell_exec ('echo E916BF00 > /proc/ir/button');
		}
		
		if ($user_input->control_id == 'ch_select_apply_all')
        {
			if ($user_input->channell_select == 'v')
				$ch_select_all = '';
			else
				$ch_select_all = $this->global_channels[$user_input->plugin_tv_channel_id]['urls'][$user_input->channell_select];
			HD::save_item('ch_select_all', $ch_select_all);
			shell_exec ('echo EA15BF00 > /proc/ir/button');
			shell_exec ('echo E916BF00 > /proc/ir/button');
		}
		
		if ($user_input->control_id == 'ch_select_apply')
        {
			$ch_select = HD::get_items('ch_select');
			if (($user_input->channell_select == 'v')&&(isset($ch_select[$user_input->plugin_tv_channel_id])))
				unset ($ch_select[$user_input->plugin_tv_channel_id]);
			else
				$ch_select[$user_input->plugin_tv_channel_id] = $user_input->channell_select;
			HD::save_items('ch_select', $ch_select);
			shell_exec ('echo EA15BF00 > /proc/ir/button');
			shell_exec ('echo E916BF00 > /proc/ir/button');
		}
		
		if ($user_input->control_id == 'oth_menu'){
			$defs = array();
			$zoom = HD::get_items('zoom', &$plugin_cookies);
			$channel_id = $user_input->plugin_tv_channel_id;
			$dune_zoom = isset($zoom[$channel_id]) ? $zoom[$channel_id] : 'v';
			$dune_zoom_ops['v'] = '%tr%t95';
			$dune_zoom_ops[0] = '%tr%t96';
			$dune_zoom_ops[1] = '%tr%t97';
			$dune_zoom_ops[2] = '%tr%t98';
			$dune_zoom_ops[3] = '%tr%t99';
			$dune_zoom_ops[4] = '%tr%t100';
			$dune_zoom_ops[5] = '%tr%t101';
			$dune_zoom_ops[6] = '%tr%t102';
			$dune_zoom_ops[8] = '%tr%t103';
			$dune_zoom_ops[9] = '%tr%t104';
			ControlFactory::add_button_close ($defs, $this, $add_params=null,'sleep',
				"", 'Sleep Timer', 600);
			ControlFactory::add_label($defs,'', '%tr%t105');
			ControlFactory::add_combobox($defs, $this, null,
            'zoom_select', '',
            $dune_zoom, $dune_zoom_ops, 1000, $need_confirm = false, $need_apply = false
			);
			ControlFactory::add_button_close ($defs, $this, $add_params=null,'zoom_apply',
			"", '%tr%t107', 600);
			ControlFactory::add_label($defs,'', '%tr%t106');
			if (smbtree::get_folder_info('rec_dir_path') != ''){
				ControlFactory::add_button_close ($defs, $this, $add_params=null,'background_rec',
				"", '%tr%t108', 600);	
				$bgr_rs = DuneSystem::$properties['tmp_dir_path'] . '/background_rec_stop';
				if (file_exists($bgr_rs)) {
					$name = trim(file_get_contents($bgr_rs));
					$dd = "/tmp/".$name."_iptvrecord.sh";
					if (!file_exists($dd))
						unlink($bgr_rs);
					ControlFactory::add_label($defs,'', $name);
					ControlFactory::add_button_close ($defs, $this, $add_params=null,'background_stoprec',
					'', '%tr%t109', 600);	
				}
				if (!preg_match("|[a-zA-Z]|", $channel_id))
					ControlFactory::add_button_close ($defs, $this, $add_params=null,'info',
					"", '%tr%t110', 600);
				ControlFactory::add_button_close ($defs, $this, $add_params=null,'new_rec',
				"", '%tr%t111', 600);
				ControlFactory::add_button_close ($defs, $this, $add_params=null,'one_rec',
				"", '%tr%t112', 600);
			}else
				ControlFactory::add_label($defs,'', '%tr%t113');
			return ActionFactory::show_dialog('%tr%t114', $defs,true,0,$attrs);
		}
		
		if ($user_input->control_id == 'one_rec')
		{
			$defs = array();
			$cron_file = '/tmp/cron/crontabs/root';
			$texts = explode('###', file_get_contents($cron_file));
			unset($texts[0]);
			$texts = array_values($texts);
			$ndx_rec = 1;
			foreach($texts as $text){
				$tmp = explode('*', $text);
				$time =$tmp[0];
				preg_match( '|\/tmp/(.*?)_iptvrecord.sh|', $text , $matches);
				$file_rec = $matches[1];
				$rec_path = smbtree::get_folder_info('rec_dir_path')."/";
				ControlFactory::add_label($defs, "$ndx_rec", $time);
				++$ndx_rec;
			}
			if ($ndx_rec == 1){
				ControlFactory::add_label($defs, "", '%tr%t115');
				$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
				$attrs['actions'] = null;
				ControlFactory::add_close_dialog_button($defs,'Ок', 350);
				return ActionFactory::show_dialog('%tr%t112', $defs,true,0,$attrs);
			}
			$rec_del = '0';
			$rec_ops[0] = '%tr%t116';
			foreach($texts as $text){
				$tmp = explode('*', $text);
				$rec_ops[] = $tmp[0];
			}
			ControlFactory::add_label($defs, "", '%tr%t117');
			ControlFactory::add_combobox($defs, $this, null,
				'rec_del', '',
				$rec_del, $rec_ops, 0, $need_confirm = false, $need_apply = false
			);
			$do_rec_del = UserInputHandlerRegistry::create_action($this, 'rec_del');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_do_rec_del', '%tr%t118', 350, $do_rec_del);
			$rec_del_menu = UserInputHandlerRegistry::create_action($this, 'rec_del_menu');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_del', '%tr%t119', 350,  $rec_del_menu);
			return  ActionFactory::show_dialog('%tr%t112',$defs,true,0,$attrs);
		}

		if ($user_input->control_id === 'rec_del_menu')
		{
			$defs = array();
			$cron_file = '/tmp/cron/crontabs/root';
			$doc = file_get_contents($cron_file);
			$texts = explode('###', $doc);
			foreach ($texts as $text){
			$one_del = "###" . strstr($text, 'iptvrecord.sh', true) .'iptvrecord.sh';
			$doc = str_replace($one_del, '', $doc);
			}

			$date_cron = fopen($cron_file,"w");
			if (!$date_cron)
				ActionFactory::show_title_dialog('%tr%t5');

			fwrite($date_cron, $doc);
			@fclose($date_cron);
			chmod($cron_file, 0575);
			shell_exec('crontab -e');
				ControlFactory::add_close_dialog_button($defs,
					'Ок', 350);
			return  ActionFactory::show_dialog('%tr%t120',$defs,true,0,$attrs);
		}
		
		if ($user_input->control_id === 'rec_del')
		{
            $control_id = $user_input->control_id;
			$new_value = $user_input->{$control_id};
			$cron_file = '/tmp/cron/crontabs/root';
			$doc = file_get_contents($cron_file);
			$texts = explode('###', $doc);
			$one_del = "###" . strstr($texts[$new_value], 'iptvrecord.sh', true) .'iptvrecord.sh';
			$data = str_replace($one_del, '', $doc);
			$cron_edit = fopen($cron_file,"w");
			if (!$cron_file)
				hd_print("НЕ МОГУ ЗАПИСАТЬ НА USB/HDD");
			fwrite($cron_edit, $data);
			@fclose($cron_edit);
			chmod($cron_file, 0575);
			shell_exec('crontab -e');
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'one_rec');
			return ActionFactory::invalidate_folders(array('one_rec'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'info')
        {
			$rec_type = 300;
			$ini = parse_ini_file('/config/settings.properties');
			$rec_shift =$ini['time_zone'] * 3600;
			$channel_id = $user_input->plugin_tv_channel_id;
			$channels = $this->channels;
			$c = $channels->get($channel_id);
			$title = $c->get_title();
			$streaming_url = $this->finalUrl;
			$epg_date = date("Y-m-d");
            $post_action = null;
			$tvg_rec_day = 0;
			if (isset($user_input->epg_date)){
				$epg_date = $user_input->epg_date;
				$tvg_rec_day = $epg_date;
			}
			$day_start_ts = strtotime($epg_date);
			$texts = HD::get_vsetv_epg($channel_id, $day_start_ts);
			$times = array();
			foreach($texts as $time => $value){
				$time = $time - $rec_shift;
				$times[] =$time;
			}
			$i = 0;
			foreach($texts as $time => $value)
			{
				$inf = $value["name"];
				$time_n = $time - $rec_shift;
				$time = date("H:i" , $time_n);
				$result = count($times)-1;
				$add_params ['start_tvg_times'] = $time;
				$cnt = $i+1;
				if ($cnt > $result)
					$add_params ['stop_tvg_times'] = $time;
				else{
					$time_n = $times[$cnt];
					$time_end = date("H:i" , ($times[$cnt]));
					$add_params ['stop_tvg_times'] = $time_end;
				}
				$add_params ['tvg_rec_day'] = $tvg_rec_day;
				$add_params ['inf'] = $inf;
				$unix_time = time() - $rec_shift;
				if ($time_n < $unix_time)
					ControlFactory::add_label($defs, $time, $inf);
				else{
					if (($rec_type >= 0) && ($add_params ['stop_tvg_times'] != $add_params ['start_tvg_times'])){
						$rec_start_do = date("dm", $unix_time);
						$tmp = explode(':', $add_params ['start_tvg_times']);
						$shift = (mktime($tmp[0], $tmp[1], 0,0, 0, 0)) - $rec_type;
						$rec_start_to = date("Hi" , $shift);
						$rec_stop_do = date("dm", $unix_time);
						$tmp = explode(':', $add_params ['stop_tvg_times']);
						$shift = (mktime($tmp[0], $tmp[1], 0,0, 0, 0)) + $rec_type;
						$rec_stop_to  = date("Hi" , $shift);
						$year =  date("y");

						if (!$tvg_rec_day == '0'){
							$rec_day =  explode('-', $tvg_rec_day);
							$rec_start_do = $rec_day[2] . $rec_day[1];
							$rec_stop_do = $rec_start_do;
						}
						$c_time= intval(date("Hi", $unix_time));
						$c_day_start = intval($rec_start_to);
						$c_day_stop = intval($rec_stop_to);

						if(($c_day_start <= 500) && ($c_time > 500)){
							$unix_t = time() + $rec_shift + 86400;
							$rec_start_do = date("dm", $unix_t);
						}
						if(($c_day_stop <= 500)&& ($c_time > 500)){
							$unix_t = time() + $rec_shift + 86400;
							$rec_stop_do = date("dm", $unix_t);
						}
						if ((!$tvg_rec_day == '0') && ($c_day_start <= 500)){
							$date = strtotime($tvg_rec_day);
							$date = strtotime("+1 day", $date);
							$rec_start_do = date('dm', $date);
						}
						if ((!$tvg_rec_day == '0') && ($c_day_stop <= 500)){
							$date = strtotime($tvg_rec_day);
							$date = strtotime("+1 day", $date);
							$rec_stop_do = date('dm', $date);
						}
						$day = substr($rec_start_do, 0, 2);
						$mns = substr($rec_start_do, -2);
						$hrs = substr($rec_start_to, 0, 2);
						$min = substr($rec_start_to, -2);
						$timestamp = mktime($hrs, $min, 0, $mns, $day, $year);
						if($timestamp < $unix_time)
							$rec_start_to = date("Hi", $unix_time + 360);
						$add_params ['rec_start_t'] = $rec_start_to;
						$add_params ['rec_start_d'] = $rec_start_do;
						$add_params ['rec_stop_t'] = $rec_stop_to;
						$add_params ['rec_stop_d'] = $rec_stop_do;
						$add_params ['inf'] = $inf;
						ControlFactory::add_button ($defs, $this, $add_params,'new_rec_conf', $time, $inf, 900);
					}else
						ControlFactory::add_button ($defs, $this, $add_params,'new_rec', $time, $inf, 900);
				}
					$i++;
			}
			$date = strtotime($epg_date);
			$date = strtotime("+1 day", $date);
			$date = date('Y-m-d', $date);
			$add_params ['epg_date'] = $date;
			$time = '';
			$inf = '%tr%t121';
			ControlFactory::add_button_close ($defs, $this, $add_params,'info', $time, $inf, 500);
			$t = $title [$epg_date];
			return ActionFactory::show_dialog("%ext%<key_local>m__1<p>$t</p></key_local>", $defs, true,0,$attrs);
        }
		
		if ($user_input->control_id === 'new_rec_conf')
		{
			$defs = array();
			$rec_start_t = $user_input->start_tvg_times;
			$rec_stop_t = $user_input->stop_tvg_times;
			$inf = $user_input->inf;
			ControlFactory::add_label($defs, "$rec_start_t - $rec_stop_t", "$inf");
			$add_params ['rec_start_t'] = $user_input->rec_start_t;
			$add_params ['rec_start_d'] = $user_input->rec_start_d;
			$add_params ['rec_stop_t'] = $user_input->rec_stop_t;
			$add_params ['rec_stop_d'] = $user_input->rec_stop_d;
			$add_params ['inf'] = $user_input->inf;
			$new_rec_apply = UserInputHandlerRegistry::create_action($this, 'new_rec_apply', $add_params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
			'_add_new_rec_apply', '%tr%t60', 250, $new_rec_apply);
			ControlFactory::add_close_dialog_button($defs,
				'%tr%t61', 250);
			return  ActionFactory::show_dialog('%tr%t122',$defs,true,0,$attrs);
		}
		if ($user_input->control_id === 'background_stoprec')
		{
			$rec_file = DuneSystem::$properties['tmp_dir_path'] . '/background_rec_stop';
			if (!file_exists($rec_file))
				return ActionFactory::show_title_dialog_gl('%tr%t123');
			$background_rec_stop = trim(file_get_contents($rec_file));
			unlink($rec_file);
			shell_exec('/tmp/' .$background_rec_stop.'_iptvrecord.sh');
			return ActionFactory::show_title_dialog_gl('%tr%t124');
		}
		
		if ($user_input->control_id === 'background_rec')
		{
			if (!file_exists('/codecpack/script/iptv_record.sh')){
				$defs = $this->do_install_codecpack_defs($plugin_cookies);
				return  ActionFactory::show_dialog('%tr%t125',$defs, true,0,$attrs);
			}
			$channel_id = $user_input->plugin_tv_channel_id;
			$channels = $this->channels;
			$c = $channels->get($channel_id);
			$title = $c->get_title();
			$tr_title = HD::translit($title);
			$rec_path = smbtree::get_folder_info('rec_dir_path')."/";
			$streaming_url = $this->finalUrl;
			$ini = parse_ini_file('/config/settings.properties');
			$rec_shift =$ini['time_zone'] * 3600;
			$unix_time = time() - $rec_shift;
			$date = date("HidmY" , $unix_time);
			$rec_name = $tr_title .'_'. $date;
			$streaming_url = str_replace(array('http://ts://','m3u9'), array('http://','m3u8'), $streaming_url);
			$ptl = "http";
			if (preg_match("/udp:\/\/@/i",$streaming_url))
				$ptl = "udp";
			if (preg_match("/rtp:\/\/@/i",$streaming_url))
				$ptl = "rtp";
			if (preg_match("/rtsp:\/\//i",$streaming_url))
				$ptl = "rtsp";
			if (preg_match("/\.m3u8/i",$streaming_url))
				$ptl = "hls";
			if (preg_match("/\.flv/i",$streaming_url))
				$ptl = "flv";
			if (preg_match("/rtmp:\/\//i",$streaming_url))
				$ptl = "rtmp";
			$cmd_rec = "/codecpack/script/iptv_record.sh --$ptl \"$streaming_url\" \"$rec_name\" \"$rec_path\"";
			if (preg_match("|dvb:\/\/\/(.*?):|",$streaming_url, $matches))
				$cmd_rec = "/codecpack/script/iptv_record.sh --dvbt \"".$matches[1]."\" \"$rec_name\" \"$rec_path\" no";
			if (preg_match("|\?(.*?)&user_agent=(.*)|",$streaming_url, $matches)){
				if (preg_match("/\.m3u8/i",$streaming_url))
				$ptl = "hls";
				$ua = $matches[2];
				$cmd_rec = "/codecpack/script/iptv_record.sh --$ptl \"".$matches[1]."\" \"$rec_name\" \"$rec_path\" \"$ua\"";
			}	
			$free = "$rec_path";
			if (!file_exists($rec_path))
				return ActionFactory::show_title_dialog_gl('%tr%t130');
			if (preg_match("|\/tmp\/mnt\/storage\/(.*?)\/|",$rec_path, $match)){
				$bytes = disk_free_space ($match[0]);
				$si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'EB', 'ZB', 'YB' );
				$base = 1024;
				$class = min((int)log($bytes , $base) , count($si_prefix) - 1);
				$free = sprintf('%1.2f' , $bytes / pow($base,$class)) . ' ' . $si_prefix[$class];
				if ($bytes < 1000000000)
					return ActionFactory::show_title_dialog_gl("%ext%<key_local>n__1<p>$free</p></key_local>");
			}
			$rec_file = DuneSystem::$properties['tmp_dir_path'] . '/background_rec_stop';
			$date_count = fopen($rec_file,"w");
			if (!$date_count)
				return ActionFactory::show_title_dialog_gl('%tr%t131');
			fwrite($date_count, $rec_name);
			@fclose($date_count);
			shell_exec($cmd_rec);
			ControlFactory::add_label($defs, '%tr%t132', "$title");
			ControlFactory::add_label($defs, '%tr%t133', "$free");
			ControlFactory::add_label($defs, "", '%tr%t134');
			$do_br_apply = UserInputHandlerRegistry::create_action($this, 'new_br_apply');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
			'_do_br_apply', 'ОК', 250, $do_br_apply);
			return ActionFactory::show_dialog('%tr%t135', $defs,true,0,$attrs);
		}
		
		if ($user_input->control_id === 'new_rec')
		{
			
			if (!file_exists('/codecpack/script/iptv_record.sh')){
				$defs = $this->do_install_codecpack_defs($plugin_cookies);
				return  ActionFactory::show_dialog('%tr%t125',$defs, true,0,$attrs);
			}
			$stop_tvg_times = $start_tvg_times = $tvg_rec_day = 0;
			$inf = '';
			if (isset($user_input->start_tvg_times))
				$start_tvg_times = $user_input->start_tvg_times;
			if (isset($user_input->stop_tvg_times))
				$stop_tvg_times = $user_input->stop_tvg_times;
			if (isset($user_input->tvg_rec_day))
				$tvg_rec_day = $user_input->tvg_rec_day;
			if (isset($user_input->inf))
				$inf = $user_input->inf;
			$start_tvg_times = str_replace(":", "", $start_tvg_times);
			$stop_tvg_times = str_replace(":", "", $stop_tvg_times);
			
			$ini = parse_ini_file('/config/settings.properties');
			$rec_shift =$ini['time_zone'] * 3600;

			$defs = array();
			$add_params['inf'] = $inf;
			if ($start_tvg_times == '0'){
				$unix_time = time() - $rec_shift;
				$date = date("m-d H:i:s" , $unix_time);
				$rec_start_do = date("dm", $unix_time);
				$rec_start_to = date("Hi", $unix_time);
				$rec_stop_do = date("dm", $unix_time);
				$rec_stop_to = date("Hi", $unix_time);
			}
			else{
				$unix_time = time() - $rec_shift;
				$year =  date("y");
				$rec_start_do = date("dm", $unix_time);
				$rec_start_to = $start_tvg_times;
				$rec_stop_do = date("dm", $unix_time);
				$rec_stop_to = $stop_tvg_times;
				if (!$tvg_rec_day == '0'){
					$rec_day =  explode('-', $tvg_rec_day);
					$rec_start_do = $rec_day[2] . $rec_day[1];
					$rec_stop_do = $rec_start_do;
				}
				$c_time= intval(date("Hi", $unix_time));
				$c_day_start = intval($start_tvg_times);
				$c_day_stop = intval($stop_tvg_times);

				if(($c_day_start <= 500) && ($c_time > 500)){
					$unix_t = time() + $rec_shift + 86400;
					$rec_start_do = date("dm", $unix_t);
				}
				if(($c_day_stop <= 500)&& ($c_time > 500)){
					$unix_t = time() + $rec_shift + 86400;
					$rec_stop_do = date("dm", $unix_t);
				}
				if ((!$tvg_rec_day == '0') && ($c_day_start <= 500)){
					$date = strtotime($tvg_rec_day);
					$date = strtotime("+1 day", $date);
					$rec_start_do = date('dm', $date);
				}
				if ((!$tvg_rec_day == '0') && ($c_day_stop <= 500)){
					$date = strtotime($tvg_rec_day);
					$date = strtotime("+1 day", $date);
					$rec_stop_do = date('dm', $date);
				}
				$day = substr($rec_start_do, 0, 2);
				$mns = substr($rec_start_do, -2);
				$hrs = substr($rec_start_to, 0, 2);
				$min = substr($rec_start_to, -2);
				$timestamp = mktime($hrs, $min, 0, $mns, $day, $year);
				if($timestamp < $unix_time)
					$rec_start_to = date("Hi", $unix_time + 60);
			}
			ControlFactory::add_text_field($defs,0,0,
				'rec_start_t', '%tr%t136',
				$rec_start_to, 1, 0, 0, 1, 250, 0, false);
			ControlFactory::add_text_field($defs,0,0,
				'rec_start_d', '%tr%t137',
				$rec_start_do, 1, 0, 0, 1, 250, 0, false);
			ControlFactory::add_text_field($defs,0,0,
				'rec_stop_t', '%tr%t138',
				$rec_stop_to, 1, 0, 0, 1, 250, 0, false);
			ControlFactory::add_text_field($defs,0,0,
				'rec_stop_d', '%tr%t139',
				$rec_stop_do, 1, 0, 0, 1, 250, 0, false);

			$do_rec_apply = UserInputHandlerRegistry::create_action($this, 'new_rec_apply', $add_params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
			'_do_rec_apply', 'ОК', 250, $do_rec_apply);
			ControlFactory::add_close_dialog_button($defs,
				'Отмена', 250);
			return  ActionFactory::show_dialog('%tr%t140',$defs,true,0,$attrs);
		}
		
		if ($user_input->control_id === 'new_rec_apply')
		{
			$ini = parse_ini_file('/config/settings.properties');
			$rec_shift =$ini['time_zone'] * 3600;
			$seconds = '00'; $year = date("Y");
			$channel_id = $user_input->plugin_tv_channel_id;
			$channels = $this->channels;
			$c = $channels->get($channel_id);
			$title = $c->get_title();
			$streaming_url = $this->finalUrl;
			$rec_start_t = $user_input->rec_start_t;
			$rec_start_d = $user_input->rec_start_d;
			$rec_stop_t = $user_input->rec_stop_t;
			$rec_stop_d = $user_input->rec_stop_d;
			$day_e = substr($rec_stop_d, 0, 2);
			$mns_e = substr($rec_stop_d, -2);
			$day_s = substr($rec_start_d, 0, 2);
			$mns_s = substr($rec_start_d, -2);
			$year =  date("y");
			$inf = $user_input->inf;
			if (($rec_start_t >= $rec_stop_t) && ((strtotime ("$day_s.$mns_s.$year")) >= strtotime (("$day_e.$mns_e.$year"))))
				return ActionFactory::show_title_dialog_gl('%tr%t141');
			$cron_file = '/tmp/cron/crontabs/root';
			$hrs_s = substr($rec_start_t, 0, 2);
			$min_s = substr($rec_start_t, -2);
			$time_s = $hrs_s .":".$min_s;
			if (!preg_match('/^([0-1][0-9]|[2][0-3]):([0-5][0-9])$/', $time_s))
				return ActionFactory::show_title_dialog_gl('%tr%t142');

			$data_s = $day_s .":".$mns_s;
			if (!preg_match('/^([0-2][0-9]|[3][0-1]):([0-1][0-9])$/', $data_s))
				return ActionFactory::show_title_dialog_gl('%tr%t143');
			
			$timestamp = mktime($hrs_s, $min_s , $seconds, $mns_s, $day_s, $year) + $rec_shift;
			if (time() > $timestamp)
				return ActionFactory::show_title_dialog_gl('%tr%t142');
			$hrs_s1 = strftime('%H',$timestamp);
			$min_s1 = strftime('%M',$timestamp);
			$day_s1 = strftime('%d',$timestamp);
			$mns_s1 = strftime('%m',$timestamp);
			$hrs_e = substr($rec_stop_t, 0, 2);
			$min_e = substr($rec_stop_t, -2);
			$time_e = $hrs_e .":".$min_e;
			if (!preg_match('/^([0-1][0-9]|[2][0-3]):([0-5][0-9])$/', $time_e))
				return ActionFactory::show_title_dialog_gl('%tr%t142');

			$data_e = $day_e .":".$mns_e;
			if (!preg_match('/^([0-2][0-9]|[3][0-1]):([0-1][0-9])$/', $data_e))
				return ActionFactory::show_title_dialog_gl('%tr%t144');
			$timestamp = mktime($hrs_e, $min_e, $seconds, $mns_e, $day_e, $year)+ $rec_shift;
			$hrs_e1 = strftime('%H',$timestamp);
			$min_e1 = strftime('%M',$timestamp);
			$day_e1 = strftime('%d',$timestamp);
			$mns_e1 = strftime('%m',$timestamp);
			$rec_path = smbtree::get_folder_info('rec_dir_path')."/";
			$tr_title = HD::translit($title);
			$date_name = $hrs_s . $min_s . $day_s . $mns_s ."-". $hrs_e . $min_e . $day_e . $mns_e;
			$rec_name = $tr_title .'_'. $date_name;
			$streaming_url = str_replace(array('http://ts://','m3u9'), array('http://','m3u8'), $streaming_url);
			$ptl = "http";
			if (preg_match("/udp:\/\/@/i",$streaming_url))
				$ptl = "udp";
			if (preg_match("/rtp:\/\/@/i",$streaming_url))
				$ptl = "rtp";
			if (preg_match("/rtsp:\/\//i",$streaming_url))
				$ptl = "rtsp";
			if (preg_match("/\.m3u8/i",$streaming_url))
				$ptl = "hls";
			if (preg_match("/\.flv/i",$streaming_url))
				$ptl = "flv";
			if (preg_match("/rtmp:\/\//i",$streaming_url))
				$ptl = "rtmp";
			$cmd_rec = "/codecpack/script/iptv_record.sh --$ptl \"$streaming_url\" \"$rec_name\" \"$rec_path\"";

			if (preg_match("|dvb:\/\/\/(.*?):|",$streaming_url, $matches))
				$cmd_rec = "/codecpack/script/iptv_record.sh --dvbt \"".$matches[1]."\" $rec_name \"$rec_path\" no";
				if (preg_match("|\?(.*?)&user_agent=(.*)|",$streaming_url, $matches)){
				if (preg_match("/\.m3u8/i",$streaming_url))
				$ptl = "hls";
				$ua = $matches[2];
				$cmd_rec = "/codecpack/script/iptv_record.sh --$ptl \"".$matches[1]."\" \"$rec_name\" \"$rec_path\" \"$ua\"";
			}

			if (!file_exists($rec_path))
				return ActionFactory::show_title_dialog_gl('%tr%t130');
			if (preg_match("|\/tmp\/mnt\/storage\/(.*?)\/|",$rec_path, $match)){
				$bytes = disk_free_space ($match[0]);
				$si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'EB', 'ZB', 'YB' );
				$base = 1024;
				$class = min((int)log($bytes , $base) , count($si_prefix) - 1);
				$free = sprintf('%1.2f' , $bytes / pow($base,$class)) . ' ' . $si_prefix[$class];
				if ($bytes < 1000000000)
				return ActionFactory::show_title_dialog("%ext%<key_local>n__1<p>$free</p></key_local>");
			}
			$background_rec_stop = DuneSystem::$properties['tmp_dir_path'] . '/background_rec_stop';
			$save_cron = "\n###$title $inf [$hrs_s:$min_s] [$day_s-$mns_s] по [$hrs_e:$min_e] [$day_e-$mns_e]* \n$min_s1 $hrs_s1 $day_s1 $mns_s1 * $cmd_rec\n$min_s1 $hrs_s1 $day_s1 $mns_s1 * echo \"$rec_name\" > $background_rec_stop\n$min_e1 $hrs_e1 $day_e1 $mns_e1 * /tmp/". $rec_name ."_iptvrecord.sh";
			$cron_data = fopen($cron_file,"a");
			if (!$cron_data)
				hd_print("НЕ МОГУ ЗАПИСАТЬ cron");
			fwrite($cron_data, $save_cron);
			@fclose($cron_data);
			chmod($cron_file, 0575);
			shell_exec('crontab -e');
			return ActionFactory::show_title_dialog_gl("$title Start:$hrs_s:$min_s $day_s-$mns_s Stop:$hrs_e:$min_e $day_e-$mns_e");
			break;
		}
		
		if ($user_input->control_id == 'zoom_apply'){
			$zoom = HD::get_items('zoom');
			if ($user_input->zoom_select == 'v')
				unset ($zoom[$user_input->plugin_tv_channel_id]);
			else
				$zoom[$user_input->plugin_tv_channel_id] = $user_input->zoom_select;
			HD::save_items('zoom', $zoom);
			shell_exec ('echo EA15BF00 > /proc/ir/button');
			shell_exec ('echo E916BF00 > /proc/ir/button');
		}
        return null;
    }
	
	public function get_tv_info(MediaURL $media_url, &$plugin_cookies)
    {
		$actions = array();
		$actions[GUI_EVENT_KEY_B_GREEN] = UserInputHandlerRegistry::create_action($this,'ch_select',  $params=null);
		//$actions[GUI_EVENT_KEY_D_BLUE] = UserInputHandlerRegistry::create_action($this,'sleep',  $params=null);
		$actions[GUI_EVENT_KEY_CLEAR]  = UserInputHandlerRegistry::create_action($this,'oth_menu',  $params=null);
		$actions[GUI_EVENT_KEY_REPEAT] = UserInputHandlerRegistry::create_action($this, 'rec_repeat',  $params=null);
		$info = parent::get_tv_info($media_url, &$plugin_cookies);
        $info[PluginTvInfo::actions] = $actions;
        return $info;
    }
		
	private function get_sel_item_update_action(&$user_input, &$plugin_cookies)
    {
        $parent_media_url = MediaURL::decode($user_input->parent_media_url);
        $sel_ndx = $user_input->sel_ndx;
        $group = $this->tv->get_group($parent_media_url->group_id);
        $channels = $group->get_channels($plugin_cookies);

        $items[] = $this->get_regular_folder_item($group,
            $channels->get_by_ndx($sel_ndx), $plugin_cookies);
        $range = HD::create_regular_folder_range($items,
            $sel_ndx, $channels->size());

        return ActionFactory::update_regular_folder($range, false);
    }
	public function do_install_codecpack_defs(&$plugin_cookies)
    {
		$do_new_install_action = UserInputHandlerRegistry::create_action($this, 'do_new_install');
		ControlFactory::add_multiline_label($defs, '', '%tr%t145', 6);
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_subscription',
                '%tr%t146',
                600, $do_new_install_action);
        ControlFactory::add_close_dialog_button($defs,
                '%tr%t9', 600);
        return $defs;
	}
}

///////////////////////////////////////////////////////////////////////////
?>
