<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class SmartSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        parent::__construct(self::ID);
    }
	
	public static function get_media_url_str()
    {
        return MediaURL::encode(array('screen_id' => self::ID));
    }
	
    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();
		$epg_shift = isset($plugin_cookies->epg_shift) ? $plugin_cookies->epg_shift : 0;
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		$epg_font = isset($plugin_cookies->epg_font) ? $plugin_cookies->epg_font : PLUGIN_FONT_NORMAL;
		$start_tv = isset($plugin_cookies->start_tv) ? $plugin_cookies->start_tv : 0;
		$sort_channels = isset($plugin_cookies->sort_channels) ? $plugin_cookies->sort_channels : 0;
        $show_ops = array();
        $show_ops['yes'] = '%tr%t60';
        $show_ops['no'] = '%tr%t61';
		
		$buf_time_ops = array();
        $buf_time_ops[0] = '%tr%t147';
        $buf_time_ops[500] = '%tr%t148';
        $buf_time_ops[1000] = '%tr%t149';
        $buf_time_ops[2000] = '%tr%t150';
        $buf_time_ops[3000] = '%tr%t151';
        $buf_time_ops[5000] = '%tr%t152';
        $buf_time_ops[10000] = '%tr%t153';
		
		$show_sort = array();
        $show_sort[0] = '%tr%t154';
		$show_sort[1] = '%tr%t155';
		$show_sort[2] = '%tr%t156';
		$show_sort[3] = '%tr%t157';
		
		for ($i = -12; $i<13; $i++)
		$shift_ops[$i*3600] = $i;
		
		$epg_font_ops = array();
        $epg_font_ops[PLUGIN_FONT_NORMAL] = '%tr%t158';
        $epg_font_ops[PLUGIN_FONT_SMALL] = '%tr%t159';
		
		$start_ops = array();
		$start_ops[0] = '%tr%t160';
		$start_ops[1] = '%tr%t161';
		
        $this->add_combobox($defs,
            'start_tv', 
			'%tr%t162',
            $start_tv, $start_ops, 0, true
		);
		
		$this->add_button(
            $defs,'data_dialog',
            '%tr%t163',
            '%tr%t164', 0
		);
		$rec_dir = smbtree::get_folder_info ('rec_dir_path');
		if ($rec_dir == '')
			$rec_dir = '%tr%t253';
		ControlFactory::add_smart_label($defs, 
			'%tr%t165', 
			$rec_dir
		);
		
		$this->add_button($defs,
            'rec_path',
            '',
            '%tr%t166', 0
		);
		
		$this->add_combobox($defs,
            'sort_channels', 
			'%tr%t167',
            $sort_channels, $show_sort, 0, true
		);
			
		$this->add_combobox ($defs,
			'buf_time', 
			'%tr%t168', 
			$buf_time, $buf_time_ops, 0, true
		);
		
		$this->add_combobox($defs,
			'epg_shift', 
			'%tr%t169',
			$epg_shift, $shift_ops, 0, true
		);
		
		$this->add_combobox($defs, 
			'epg_font', 
			'%tr%t170', 
			$epg_font, $epg_font_ops, 0, true
		);
		
		$this->add_button(
            $defs,'pin_dialog',
            '%tr%t171',
            '%tr%t172', 0
		);
		
		$this->add_button(
            $defs,'vsetv_update',
            '%tr%t173',
            '%tr%t174', 0
		);
		
        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
		if ($user_input->control_id === 'sort_channels'){
			$plugin_cookies->sort_channels = $user_input->sort_channels;
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'reset_controls');
			return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
		}
		if ($user_input->control_id === 'buf_time')
			$plugin_cookies->buf_time = $user_input->buf_time;
		if ($user_input->control_id === 'epg_shift')
			$plugin_cookies->epg_shift = $user_input->epg_shift;
		if ($user_input->control_id === 'epg_font')
			$plugin_cookies->epg_font = $user_input->epg_font;
		if ($user_input->control_id === 'start_tv')
			$plugin_cookies->start_tv = $user_input->start_tv;
		if ($user_input->control_id === 'data_path'){
            $media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'data_dir_path'
                    )
                );
				return ActionFactory::open_folder($media_url,'%tr%t175');
		}
		if ($user_input->control_id === 'rec_path'){
            $media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'rec_dir_path'
                    )
                );
				return ActionFactory::open_folder($media_url,'%tr%t176');
		}
		if ($user_input->control_id === 'vsetv_update'){
			$doc = iconv('WINDOWS-1251', 'UTF-8',HD::http_get_document('http://www.vsetv.com/channels.html'));
			preg_match_all('|<option value=channel_(.*?)>(.*?)</option>|ms', $doc, $matches);
			foreach ($matches[2] as $k => $v){
				$vsetv_channels_id[HD::get_id_key($v)] = $matches[1][$k];
				$vsetv_channels[$v] = $matches[1][$k];
			}
			HD::save_items('vsetv_channels_id', $vsetv_channels_id);
			HD::save_items('vsetv_channels', $vsetv_channels);
			$t= count ($vsetv_channels_id);
			return ActionFactory::show_title_dialog('%tr%t177',null,"%ext%<key_local>o__1<p>$t</p></key_local>",800);
		}
		if ($user_input->control_id === 'pin_dialog'){
			$defs = array();
			$this->add_text_field($defs,
				'pin1', '%tr%t178',
				'', 1, 1, 0, 1, 500, 0, false);
			$this->add_text_field($defs,
				'pin2', '%tr%t179',
				'', 1, 1, 0, 1, 500, 0, false);
			$this->add_label($defs, '%tr%t180', '');
			$this->add_close_dialog_and_apply_button($defs,'pin_apply', '%tr%t21', 250);					
			return  ActionFactory::show_dialog('%tr%t181',	$defs, true);
		}
		if ($user_input->control_id === 'data_dialog'){
			$defs = array();
			ControlFactory::add_multiline_label($defs, '%tr%t182', '%tr%t183',6);
			ControlFactory::add_img_label($defs, '', '%tr%t184', 0, 0, 0);
			ControlFactory::add_smart_label($defs, 
				'%tr%t163', 
				'<text color="10" size="normal">'.SmartConfig::get_data_path().'</text>'
			);
			$this->add_button($defs,
				'data_path',
				'%tr%t163',
				'%tr%t185',
				850
			);
	
			$this->add_button(
				$defs,
				'export_data',
				'%tr%t185',
				'%tr%t187',
				850
			);
				
			$this->add_button(
				$defs,
				'import_data',
				'%tr%t188',
				'%tr%t189',
				850
			);
				
			$this->add_button(
				$defs,
				'import_file_data',
				'%tr%t190',
				'%tr%t189',
				850
			);
				
			$this->add_button(
				$defs,
				'clear_data',
				'',
				'%tr%t191',
				850
			);
				
			return  ActionFactory::show_dialog('%tr%t163',$defs, true,1200);
		}
		if ($user_input->control_id === 'clear_data'){
			if (file_exists(DuneSystem::$properties['data_dir_path']))
				shell_exec("rm -rf ".DuneSystem::$properties['data_dir_path']);
			if (!file_exists(DuneSystem::$properties['data_dir_path']))
				mkdir(DuneSystem::$properties['data_dir_path'],0777,true);
			$do_actions = ActionFactory::show_title_dialog_gl('%tr%t192');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'import_data'){
			$media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'import_data'
                    )
                );
			$do_actions = ActionFactory::open_folder($media_url,'Folders');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'import_file_data'){
			$media_url = MediaURL::encode (
                array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' 		=> 'setup',
						'action' 		=> 'import_file_data',
						'extension' 	=> 'all_extension'
						),
                    )
				);
			$do_actions = ActionFactory::open_folder($media_url,'%tr%t193');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'reset_controls')
			return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
		if ($user_input->control_id === 'export_data'){
			$media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'export_data'
                    )
                );
			$do_actions = ActionFactory::open_folder($media_url,'Folders');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'pin_apply'){
			$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';
			if ($user_input->pin1 == '' || $user_input->pin2 == '')
				$msg = '%tr%t194';
			else if ($user_input->pin1 == $pin){
				$plugin_cookies->pin = $user_input->{'pin2'};
				$msg = '%tr%t195';
			}
			else
				$msg = '%tr%t194';
				return  ActionFactory::show_title_dialog($msg,$action = null);
		}
        return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
