<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';

///////////////////////////////////////////////////////////////////////////

class TvGroupListScreen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'tv_group_list';

    ///////////////////////////////////////////////////////////////////////

    protected $tv;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($tv, $folder_views)
    {
        parent::__construct(self::ID, $folder_views);

        $this->tv = $tv;
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        $actions = array();
		$q =  HD::ver();
		$add_action = ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'%tr%t196');
		$actions[GUI_EVENT_KEY_SETUP] = $add_action;
		$add_action = UserInputHandlerRegistry::create_action($this, 'whats_new');
        $add_action['caption'] = "%ext%<key_local>d__1<p>$q</p></key_local>";
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		$add_action = UserInputHandlerRegistry::create_action($this, 'add_category');
        $add_action['caption'] = '%tr%t197';
        $actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		$add_action = UserInputHandlerRegistry::create_action($this, 'sel_pls');
        $add_action['caption'] = '%tr%t198';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_ENTER] = ActionFactory::open_folder();
		$actions[GUI_EVENT_KEY_PLAY]  = ActionFactory::tv_play();
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		return  $actions;
    }
	
	public function get_handler_id()
    { return self::ID; }
    ///////////////////////////////////////////////////////////////////////
	
	public function handle_user_input(&$user_input, &$plugin_cookies)
    {
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ($user_input->control_id == 'add_category')
        {
            if (!isset($user_input->selected_media_url))
                return null;
			$defs = array();
			ControlFactory::add_text_field($defs,
				$this, $add_params=null,
				'newname', '',
				'', 0, 0, 1, 1, 1300, 0, 1);
			ControlFactory::add_vgap($defs, 500);	
			return  ActionFactory::show_dialog('%tr%t199',$defs,true);
        }
		if ($user_input->control_id == 'newname')
        {
			if ($user_input->newname == '')
				return ActionFactory::show_title_dialog('%tr%t200');
			$do = UserInputHandlerRegistry::create_action($this, 'add_category_apply');
			return ActionFactory::close_dialog_and_run($do);
		}
		if ($user_input->control_id === 'sel_pl_folder'){
                $media_url = MediaURL::encode
                (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_data'		=> 'pl_folder'
                    )
                );
				return ActionFactory::open_folder($media_url,'%tr%t201');
		}
		if ($user_input->control_id === 'pl_select'){
                $media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent'		=> 'tv_group_list',
						'action'		=> 'pl_folder',
						'arg'			=> 0,
						'extension'		=> 'm3u'
						),
                    )
				);
				return ActionFactory::open_folder($media_url,'%tr%t202');
		}
		else if ($user_input->control_id === 'pltxt_select'){
                $media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent'		=> 'tv_group_list',
						'action'		=> 'pl_folder',
						'arg'			=> 0,
						'extension'		=> 'txt'
						),
                    )
				);
				return ActionFactory::open_folder($media_url,'%tr%t202');
		}
		if ($user_input->control_id === 'sel_pls'){
			$defs = array();
			ControlFactory::add_multiline_label($defs,'' ,'%tr%t203',5);
			$run = UserInputHandlerRegistry::create_action($this, 'sel_pl_folder');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pl_folder', '%tr%t204', 450, $run);
			$run = UserInputHandlerRegistry::create_action($this, 'pl_select');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pl_select', '%tr%t16', 450, $run);
			$run = UserInputHandlerRegistry::create_action($this, 'pltxt_select');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pltxt_select', '%tr%t17', 450, $run);
			$run = UserInputHandlerRegistry::create_action($this, 'url_select');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'url_select', '%tr%t18', 450, $run);
			$run = UserInputHandlerRegistry::create_action($this, 'prov_pl');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'prov_pl', '%tr%t19', 450, $run);
			$run = UserInputHandlerRegistry::create_action($this, 'selected_pl');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'pl_select', '%tr%t206', 450, $run);
			return ActionFactory::show_dialog('%tr%t207', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'prov_pl'){
			$defs = array();		
			$ch_ops = HD::load_prov_info();
			ControlFactory::add_combobox($defs, $this, null,
            'do_new_url', '%tr%t208',
            0, $ch_ops, 500, $need_confirm = false, $need_apply = false
			);
			$do_prov_pl_apply = UserInputHandlerRegistry::create_action($this, 'do_url');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
			'_prov_pl_apply', '%tr%t21', 250, $do_prov_pl_apply);
			return  ActionFactory::show_dialog('%tr%t209', $defs, true);
		}
		if ($user_input->control_id === 'url_select'){
			$defs = array();
			ControlFactory::add_text_field($defs,
			$this, $add_params=null,
			'do_new_url', '',
			'http://', 0, 0, 1, 1, 1300,0,1);
			ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog('%tr%t210', $defs, true);
		}
		if ($user_input->control_id == 'do_new_url')
        {
			$do_search = UserInputHandlerRegistry::create_action($this, 'do_url');
			return ActionFactory::close_dialog_and_run($do_search);
		}
		if ($user_input->control_id === 'do_url'){
			$link = DuneSystem::$properties['data_dir_path'] . '/pl_folder';
			$pl_folders = unserialize(file_get_contents($link));
			$pl_folders[]['pl_url'] = $user_input->do_new_url;
			$data = fopen($link,"w");
			if (!$data)
				return ActionFactory::show_title_dialog('%tr%t5');
			fwrite($data, serialize($pl_folders));
			@fclose($data);
			$perform_new_action = UserInputHandlerRegistry::create_action($this, 'sel_pls');
			return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
		}
		if ($user_input->control_id === 'selected_pl'){
			$defs = array();
			$pl_folders = unserialize(file_get_contents(DuneSystem::$properties['data_dir_path'] . '/pl_folder'));
			if (empty($pl_folders)){
				ControlFactory::add_label($defs,'', '%tr%t211');
			}else
				ControlFactory::add_label($defs,'%tr%t212', '');
			if (!empty($pl_folders))
			foreach ($pl_folders as $k => $v){
				if (isset($v['file_name'])){
					$q = array_slice($v, 0, 1);
				}elseif (!isset($v['pl_url']))
					$q = $v;
				if (!isset($v['pl_url']))
					$m3u_dir = smbtree::get_folder_info ($q);
				if (isset($v['file_name'])){
					if (isset($q['filepath']))
						$add_params['filepath']=$q['filepath'];
					else
						$add_params['m3u_dir']= key($q);
					if (isset($q['foldername']))
						$add_params['foldername']= $q['foldername'];
					$add_params['file_name']= $v['file_name'];
					ControlFactory::add_button_close ($defs, $this, $add_params,'del_m3u',  'Playlist:'.$m3u_dir .'/'. $v['file_name'], '%tr%t213', 0);
				}elseif (isset($v['pl_url'])){
					$add_params['nbr']= $k;
					ControlFactory::add_button_close ($defs, $this, $add_params, 'del_m3u_http',  'URL:'.$v['pl_url'], '%tr%t213', 0);
				}else{
					if (isset($q['filepath']))
						$add_params['m3u_dir']=$q['filepath'];
					else{
						$add_params['m3u_dir']=key($q);
						if (isset($q[key($q)]['foldername']))
							$add_params['foldername']=$q[key($q)]['foldername'];
					}
					ControlFactory::add_button_close ($defs, $this, $add_params, 'del_m3u_dir',  'Folder:'.$m3u_dir, '%tr%t213', 0);
				}
			}
			return ActionFactory::show_dialog('%tr%t214', $defs, true, 0, $attrs);
		}
		if ($user_input->control_id == 'del_m3u_http'){
			$link = DuneSystem::$properties['data_dir_path'] . '/pl_folder';
			$pl_folders = unserialize(file_get_contents($link));
			unset ($pl_folders[$user_input->nbr]);
			$data = fopen($link,"w");
			if (!$data)
				return ActionFactory::show_title_dialog('%tr%t5');
			fwrite($data, serialize($pl_folders));
			@fclose($data);
			if (empty($pl_folders))
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'sel_pls');
			else
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'selected_pl');
			return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'del_m3u_dir'){
			$link = DuneSystem::$properties['data_dir_path'] . '/pl_folder';
			$pl_folders = unserialize(file_get_contents($link));
			foreach ($pl_folders as $k => $v){
				if ((isset($v['filepath']))&&($v['filepath']==$user_input->m3u_dir))
					unset ($pl_folders[$k]);
				else if ((isset($v[$user_input->m3u_dir]))&&($v[$user_input->m3u_dir]['foldername']==$user_input->foldername))
					unset ($pl_folders[$k]);
			}
			$data = fopen($link,"w");
			if (!$data)
				return ActionFactory::show_title_dialog('%tr%t5');
			fwrite($data, serialize($pl_folders));
			@fclose($data);
			if (empty($pl_folders))
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'sel_pls');
			else
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'selected_pl');
			return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
		}
		
		if ($user_input->control_id == 'del_m3u'){
			$link = DuneSystem::$properties['data_dir_path'] . '/pl_folder';
			$pl_folders = unserialize(file_get_contents($link));
			foreach ($pl_folders as $k => $v){
				if ((isset($user_input->m3u_dir))
				&&(isset($v[$user_input->m3u_dir]))
				&&($v['file_name']==$user_input->file_name))
					unset ($pl_folders[$k]);
				else if ((!isset($user_input->m3u_dir))&&
				(isset($user_input->filepath))&&
				(isset($v['filepath']))&&
				($v['filepath']==$user_input->filepath)&&
				($v['file_name']==$user_input->file_name))
					unset ($pl_folders[$k]);
			}
			$data = fopen($link,"w");
			if (!$data)
				return ActionFactory::show_title_dialog('%tr%t5');
			fwrite($data, serialize($pl_folders));
			@fclose($data);
			if (empty($pl_folders))
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'sel_pls');
			else
				$perform_new_action = UserInputHandlerRegistry::create_action($this, 'selected_pl');
			return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
		}
				
		if ($user_input->control_id === 'cleer_folder')
		{
			if (!isset($user_input->parent_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$sel_ndx = $user_input->sel_ndx;
				if ($sel_ndx < 0)
					$sel_ndx = 0;
			$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
			return ActionFactory::update_regular_folder($range, true, $sel_ndx);
		}
		
		if ($user_input->control_id == 'add_category_apply')
        {
            if (!isset($user_input->selected_media_url))
                return null;
			$group_names = HD::get_items('group_names');
			$group_names[] = $user_input->newname;
			HD::save_items('group_names', $group_names);
			$trans = array_flip ($group_names);
			$action = 'plugin_ico';
			$arg = $trans[$user_input->newname]+14;
			$msg = '%tr%t215';
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' => self::ID,
						'action' => $action,
						'arg' => $arg,
						'msg' => $msg,
						'extension' => 'png'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t216');
        }
		if ($user_input->control_id == 'add_group_img')
        {
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if ($user_input->selected_media_url =='tv_group_list'){
				$action = 'plugin_ico';
				$arg = 'tv_group_list';
			}
			else if ($media_url->screen_id =='vod_favorites'){
				$action = 'plugin_ico';
				$arg = 'vod_favorites';
			}
			else{
				$action = 'portals_link';
				$arg = $media_url->category_id;
			}
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' => self::ID,
						'action' => $action,
						'arg' => $arg,
						'extension' => 'png'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'Folders');
		}

		if ($user_input->control_id == 'del_plugin_img')
        {
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$plugin_ico = HD::get_items('plugin_ico');
			if (isset($plugin_ico[$media_url->group_id])){
				$mci = $plugin_ico[$media_url->group_id];
				unset ($plugin_ico[$media_url->group_id]);
			}
			if (isset($plugin_ico[$media_url->screen_id])){
				$mci = $plugin_ico[$media_url->screen_id];
				unset ($plugin_ico[$media_url->screen_id]);
			}
			HD::save_items('plugin_ico', $plugin_ico);
			unlink($mci);
			return ActionFactory::invalidate_folders(array(self::ID), null);
		}
		
		if ($user_input->control_id == 'add_portal_img')
        {
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			if ($media_url->screen_id =='tv_favorites')
				$arg = 'tv_favorites';
			else
				$arg = $media_url->group_id;
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' => self::ID,
						'action' => 'plugin_ico',
						'arg' => $arg,
						'extension' => 'png'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t217');
		}
		
		if ($user_input->control_id == 'up_group')
		{
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$group = $this->tv->get_group($media_url->group_id);
			$name_pl = $group->get_title();				
			$group_list = HD::get_items('group_list');
			$group_list = array_flip($group_list);
			unset ($group_list[$name_pl]) ;
			$group_list = array_flip($group_list);
			array_unshift($group_list, $name_pl);
			HD::save_items('group_list', $group_list);
			return ActionFactory::invalidate_folders(array('tv_group_list'), null);
		}
		
		if ($user_input->control_id == 'del_group')
		{
            if (!isset($user_input->selected_media_url))
                return null;
			$media_url = MediaURL::decode($user_input->selected_media_url);
			$group_names = HD::get_items('group_names');
			unset ($group_names[$user_input->group_names_id]);
			HD::save_items('group_names', $group_names);
			$group = $this->tv->get_group($media_url->group_id);
			$name_pl = $group->get_title();				
			$group_list = HD::get_items('group_list');
			$group_list = array_flip($group_list);
			if (isset($group_list[$name_pl]))
			unset ($group_list[$name_pl]);
			$group_list = array_flip($group_list);
			array_unshift($group_list, $name_pl);
			HD::save_items('group_list', $group_list);
			return ActionFactory::invalidate_folders(array('tv_group_list'), null);
		}
		
		if ($user_input->control_id == 'add_tv_group_bg')
        {
            if (!isset($user_input->selected_media_url))
                return null;
			$msg = '%tr%t44';
			$media_url = MediaURL::encode (
                    array
                    (
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent' => self::ID,
						'action' => 'plugin_ico',
						'arg' => 'tv_group_bg',
						'msg' => $msg,
						'extension' => 'jpg'
						),
                    )
			);
			return ActionFactory::open_folder($media_url,'%tr%t218');
		}
		
		if ($user_input->control_id == 'del_tv_group_bg')
        {
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);
			$plugin_ico = HD::get_items('plugin_ico');
			unlink($plugin_ico['tv_group_bg']);
			unset ($plugin_ico['tv_group_bg']);
			HD::save_items('plugin_ico', $plugin_ico);
			return ActionFactory::invalidate_folders(array('vod_category_list'), 
			ActionFactory::show_title_dialog('%tr%t219',null,'%tr%t44',800));
		}
		if ($user_input->control_id == 'whats_new')
        {
				$post_action = null;
						$doc = HD::http_get_document('http://dune-club.info/plugins/update/'.DuneSystem::$properties['plugin_name'].'/info.txt');
						ControlFactory::add_img_label($defs, '', '%tr%t220', 0, 0, 0);
						//ControlFactory::add_img_label($defs, '', '<icon>gui_skin://small_icons/info.aai</icon><text dy="7" size="small"> кнопка INFO в категориях - информация</text>', 0, 0, 0);
						$t = DuneSystem::$properties['install_dir_path'].'/icons/setup.png';
						ControlFactory::add_img_label($defs, '', "%ext%<key_local>p__1<p>$t</p></key_local>", 0, 0, 0);
						ControlFactory::add_multiline_label($defs, '', $doc, 10);
						ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
						return ActionFactory::show_dialog('%tr%t221', $defs, true, 1100);
        }
		if ($user_input->control_id == 'popup_menu')
        {
            if (!isset($user_input->selected_media_url))
                return null;
            $media_url = MediaURL::decode($user_input->selected_media_url);

			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t222',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_portal_img'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			
			$plugin_ico = HD::get_items('plugin_ico');
			if ((isset($plugin_ico[$media_url->group_id]))||
				(isset($plugin_ico[$media_url->screen_id]))){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t223',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_plugin_img'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
			
			if ($media_url->screen_id != 'tv_favorites'){
				$up_group_action = UserInputHandlerRegistry::create_action($this, 'up_group');
				$up_group_caption = '%tr%t224';
				$menu_items[] = array(
				GuiMenuItemDef::caption => $up_group_caption,
				GuiMenuItemDef::action => $up_group_action);
			}
			$group_names = HD::get_items('group_names');
			$group_names_id = $media_url->group_id - 14;
			if (isset($group_names[$group_names_id])){
				$add_params['group_names_id'] = $group_names_id;
				$menu_items[] = array(
				GuiMenuItemDef::caption =>  '%tr%t225',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_group',$add_params),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
				
			$menu_items[] = array(
            GuiMenuItemDef::caption => '%tr%t218',
            GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_tv_group_bg'),
			GuiMenuItemDef::icon_url => 'gui_skin://small_icons/photo_viewer.aai'
			);
			
			if (isset($plugin_ico['tv_group_bg'])){
				$menu_items[] = array(
				GuiMenuItemDef::caption => '%tr%t226',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'del_tv_group_bg'),
				GuiMenuItemDef::icon_url => 'gui_skin://special_icons/off.aai'
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
        }
        return null;
    }
	
    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
		$this->tv->folder_entered($media_url, $plugin_cookies);
        $this->tv->ensure_channels_loaded($plugin_cookies);

        $items = array();
		$group_list = HD::get_items('group_list');
		$i=1000;
        foreach ($this->tv->get_groups() as $group)
        {
            $media_url = $group->is_favorite_channels() ?
                TvFavoritesScreen::get_media_url_str() :
                TvChannelListScreen::get_media_url_str($group->get_id());

            $key = false;
			if ($group->get_id()=='__favorites')
				$n = 0;
			else{
				$key = array_search($group->get_title(), $group_list);
				if ($key === false)
					$n = $i;
				else
					$n = $key+2;
			}

			$items[$n] = array
            (
                PluginRegularFolderItem::media_url => $media_url,
                PluginRegularFolderItem::caption => $group->get_title(),
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $group->get_icon_url(),
                    ViewItemParams::item_detailed_icon_path => $group->get_icon_url()
                )
            );
			$i++;
        }
		ksort($items);
		$items = array_values($items);
        $this->tv->add_special_groups($items);
        return $items;
    }

    public function get_archive(MediaURL $media_url)
    {
        return $this->tv->get_archive($media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
